package be.godot.sc.apps.eid.be;

import java.security.MessageDigest;

import be.godot.sc.engine.BelpicCard;
import be.godot.util.TextUtils;

public class ScGenerateAndVerifyAuthenticationSignature {
	public static void main(String[] args) {
		if (args.length != 0) {
			System.out.println(
				"Usage: ScGenerateAndVerifyAuthenticationSignature");
			System.exit(-1);
		}
		try {
			BelpicCard scd = new BelpicCard("");
	
			byte[] toBeSigned = "this data is being signed".getBytes();

			MessageDigest md = MessageDigest.getInstance("SHA1");
			md.update(toBeSigned);

			byte[] refsignature =
				scd.generateAuthenticationSignature(md.digest());

			System.out.println(
				"signed data = <" + TextUtils.hexDump(toBeSigned) + ">");
			System.out.println(
				"signature = <" + TextUtils.hexDump(refsignature) + ">");

			java.security.Signature sig =
				java.security.Signature.getInstance("SHA1WITHRSA");
			sig.initVerify(scd.getPublicAuthenticationKey());
			sig.update(toBeSigned);
			boolean validSignature = sig.verify(refsignature);

			System.out.println(
				"Signature verification returns <" + validSignature + ">");

		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
}
