package be.godot.sc.apps.eid.be;

import be.godot.sc.engine.BelpicCard;
import be.godot.util.FileUtils;
import be.godot.util.TextUtils;


public class ScReadCitizenAddressData {
	public static void main(String[] args) {
		if (args.length != 1) {
			System.out.println(
				"Usage: ScReadCitizenAddressData <outputFileName>");
			System.exit(-1);
		}
		String outputFileName = args[0];
		try {
			BelpicCard scd = new BelpicCard("");

			byte[] data = scd.readCitizenAddressBytes();

			FileUtils.writeFile(outputFileName, data);


			int pos = 0;

			int tagIdentifier = TextUtils.getTagIdentifier(data, pos);
			pos += TextUtils.tagLen;

			int dataLen = TextUtils.getDataLen(data, pos);
			int lenLen = TextUtils.getLenLen(data, pos);
			pos += lenLen;

			String address = TextUtils.getString(data, pos, dataLen);
			pos += dataLen;

			System.out.println("Address = <" + address + ">");

			tagIdentifier = TextUtils.getTagIdentifier(data, pos);
			pos += TextUtils.tagLen;

			dataLen = TextUtils.getDataLen(data, pos);
			lenLen = TextUtils.getLenLen(data, pos);
			pos += lenLen;

			String zip = TextUtils.getString(data, pos, dataLen);
			pos += dataLen;

			System.out.println("Zip code = <" + zip + ">");

			tagIdentifier = TextUtils.getTagIdentifier(data, pos);
			pos += TextUtils.tagLen;

			dataLen = TextUtils.getDataLen(data, pos);
			lenLen = TextUtils.getLenLen(data, pos);
			pos += lenLen;

			String municipality = TextUtils.getString(data, pos, dataLen);
			pos += dataLen;

			System.out.println("Municipality  = <" + municipality + ">");

		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

}
