package be.godot.sc.apps.eid.be;

import be.godot.sc.engine.BelpicCard;
import be.godot.util.FileUtils;
import be.godot.util.TextUtils;


public class ScReadCitizenIdentityData {

	public final static int TAG_TWO_FIRST_FIRST_NAMES = 8;
	public final static int TAG_NOBLE_CONDITION = 14;
	public final static int TAG_SPECIAL_STATUS = 16;

	public static void main(String[] args) {
		if (args.length != 1) {
			System.out.println(
				"Usage: ScReadCitizenIdentityData <outputFileName>");
			System.exit(-1);
		}
		String outputFileName = args[0];
		try {
			BelpicCard scd = new BelpicCard("");

			byte[] data = scd.readCitizenIdentityDataBytes();

			FileUtils.writeFile(outputFileName, data);


			/**
			 * the data format specifications for this information can be found on
			 * www.fedict.be -> projecten -> eid -> documentatie -> inhoud van de
			 * elektronische chip
			 */

			int pos = 0;

			int tagIdentifier = TextUtils.getTagIdentifier(data, pos);
			pos += TextUtils.tagLen;
			int dataLen = TextUtils.getDataLen(data, pos);
			int lenLen = TextUtils.getLenLen(data, pos);
			pos += lenLen;

			String str;
			String cardNumber = str = TextUtils.getString(data, pos, dataLen);
			pos += dataLen;
			System.out.println("Card Number = <" + str + ">");

			tagIdentifier = TextUtils.getTagIdentifier(data, pos);
			pos += TextUtils.tagLen;
			dataLen = TextUtils.getDataLen(data, pos);
			lenLen = TextUtils.getLenLen(data, pos);
			pos += lenLen;

			String chipNumber = str = TextUtils.hexDump(data, pos, dataLen);
			pos += dataLen;
			System.out.println("Chip Number = <" + str + ">");

			tagIdentifier = TextUtils.getTagIdentifier(data, pos);
			pos += TextUtils.tagLen;
			dataLen = TextUtils.getDataLen(data, pos);
			lenLen = TextUtils.getLenLen(data, pos);
			pos += lenLen;

			String cardValidityBegin =
				str = TextUtils.getString(data, pos, dataLen);
			pos += dataLen;
			System.out.println(
				"Card validity start date (DD.MM.YYYY) = <" + str + ">");

			tagIdentifier = TextUtils.getTagIdentifier(data, pos);
			pos += TextUtils.tagLen;
			dataLen = TextUtils.getDataLen(data, pos);
			lenLen = TextUtils.getLenLen(data, pos);
			pos += lenLen;

			String cardValidityEnd =
				str = TextUtils.getString(data, pos, dataLen);
			pos += dataLen;
			System.out.println(
				"Card validity end date (DD.MM.YYYY) = <" + str + ">");

			tagIdentifier = TextUtils.getTagIdentifier(data, pos);
			pos += TextUtils.tagLen;
			dataLen = TextUtils.getDataLen(data, pos);
			lenLen = TextUtils.getLenLen(data, pos);
			pos += lenLen;

			String cardDeliveryMunicipality =
				str = TextUtils.getString(data, pos, dataLen);
			pos += dataLen;
			System.out.println("Card delivery municipality = <" + str + ">");

			tagIdentifier = TextUtils.getTagIdentifier(data, pos);
			pos += TextUtils.tagLen;
			dataLen = TextUtils.getDataLen(data, pos);
			lenLen = TextUtils.getLenLen(data, pos);
			pos += lenLen;

			String nationalNumber =
				str = TextUtils.getString(data, pos, dataLen);
			pos += dataLen;
			System.out.println("National Number = <" + str + ">");

			tagIdentifier = TextUtils.getTagIdentifier(data, pos);
			pos += TextUtils.tagLen;
			dataLen = TextUtils.getDataLen(data, pos);
			lenLen = TextUtils.getLenLen(data, pos);
			pos += lenLen;

			String name = str = TextUtils.getString(data, pos, dataLen);
			pos += dataLen;
			System.out.println("Name = <" + str + ">");

			tagIdentifier = TextUtils.getTagIdentifier(data, pos);
			if (tagIdentifier == TAG_TWO_FIRST_FIRST_NAMES) {
				pos += TextUtils.tagLen;
				dataLen = TextUtils.getDataLen(data, pos);
				lenLen = TextUtils.getLenLen(data, pos);
				pos += lenLen;

				String twoFirstFirstNames =
					str = TextUtils.getString(data, pos, dataLen);
				pos += dataLen;
				System.out.println("2 First First Names = <" + str + ">");

				tagIdentifier = TextUtils.getTagIdentifier(data, pos);
			}
			pos += TextUtils.tagLen;
			dataLen = TextUtils.getDataLen(data, pos);
			lenLen = TextUtils.getLenLen(data, pos);
			pos += lenLen;

			String firstLetterThirdFirstName =
				str = TextUtils.getString(data, pos, dataLen);
			pos += dataLen;
			System.out.println(
				"First letter of 3rd first name = <" + str + ">");

			tagIdentifier = TextUtils.getTagIdentifier(data, pos);
			pos += TextUtils.tagLen;
			dataLen = TextUtils.getDataLen(data, pos);
			lenLen = TextUtils.getLenLen(data, pos);
			pos += lenLen;

			String nationality =
				str = TextUtils.getString(data, pos, dataLen);
			pos += dataLen;
			System.out.println("Nationality = <" + str + ">");

			tagIdentifier = TextUtils.getTagIdentifier(data, pos);
			pos += TextUtils.tagLen;
			dataLen = TextUtils.getDataLen(data, pos);
			lenLen = TextUtils.getLenLen(data, pos);
			pos += lenLen;

			String birthLocation =
				str = TextUtils.getString(data, pos, dataLen);
			pos += dataLen;
			System.out.println("Birth location = <" + str + ">");

			tagIdentifier = TextUtils.getTagIdentifier(data, pos);
			pos += TextUtils.tagLen;
			dataLen = TextUtils.getDataLen(data, pos);
			lenLen = TextUtils.getLenLen(data, pos);
			pos += lenLen;

			String birthDate = str = TextUtils.getString(data, pos, dataLen);
			pos += dataLen;
			System.out.println("Birth Date (DD mmmm YYYY) = <" + str + ">");

			tagIdentifier = TextUtils.getTagIdentifier(data, pos);
			pos += TextUtils.tagLen;
			dataLen = TextUtils.getDataLen(data, pos);
			lenLen = TextUtils.getLenLen(data, pos);
			pos += lenLen;

			String sex = str = TextUtils.getString(data, pos, dataLen);
			pos += dataLen;
			System.out.println("Sex = <" + str + ">");

			tagIdentifier = TextUtils.getTagIdentifier(data, pos);
			if (tagIdentifier == TAG_NOBLE_CONDITION) {
				pos += TextUtils.tagLen;
				dataLen = TextUtils.getDataLen(data, pos);
				lenLen = TextUtils.getLenLen(data, pos);
				pos += lenLen;

				String nobleCondition =
					str = TextUtils.getString(data, pos, dataLen);
				pos += dataLen;
				System.out.println("Noble condition = <" + str + ">");

				tagIdentifier = TextUtils.getTagIdentifier(data, pos);
			}
			pos += TextUtils.tagLen;
			dataLen = TextUtils.getDataLen(data, pos);
			lenLen = TextUtils.getLenLen(data, pos);
			pos += lenLen;

			String documentType =
				str = TextUtils.getString(data, pos, dataLen);
			pos += dataLen;
			System.out.println("Document type = <" + str + ">");

			tagIdentifier = TextUtils.getTagIdentifier(data, pos);
			if (tagIdentifier == TAG_SPECIAL_STATUS) {
				pos += TextUtils.tagLen;
				dataLen = TextUtils.getDataLen(data, pos);
				lenLen = TextUtils.getLenLen(data, pos);
				pos += lenLen;

				String specialStatus =
					str = TextUtils.getString(data, pos, dataLen);
				pos += dataLen;
				System.out.println("Special status = <" + str + ">");

				tagIdentifier = TextUtils.getTagIdentifier(data, pos);
			}
			pos += TextUtils.tagLen;
			dataLen = TextUtils.getDataLen(data, pos);
			lenLen = TextUtils.getLenLen(data, pos);
			pos += lenLen;

			String hashPhoto = str = TextUtils.hexDump(data, pos, dataLen);
			pos += dataLen;
			System.out.println("Hash Photo = <" + str + ">");
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
}
