package be.godot.sc.apps.eid.be;

import be.godot.sc.engine.BelpicCard;
import be.godot.util.FileUtils;

public class ScReadEverything {
	public static void main(String[] args) {
		if (args.length != 1) {
			System.out.println("Usage: ScReadATR <fileNamePrefix>");
			System.exit(-1);
		}

		String prefix = args[0];

		try {
			System.out.println("initializing smartcard engine");
			long startTime = System.currentTimeMillis();
			BelpicCard scd = new BelpicCard("");
			long elapsed = System.currentTimeMillis() - startTime;

			System.out.println("time = <" + System.currentTimeMillis()
					+ ">, elapsed = <" + elapsed + ">");

			/////////////////////////////////////////////////////

			startTime = System.currentTimeMillis();
			System.out
					.println("reading out citizen authentication certificate");
			FileUtils.writeFile(prefix + "AuthenticationCertificate.der", scd
					.getAuthCertificateBytes());
			elapsed = System.currentTimeMillis() - startTime;

			System.out.println("time = <" + System.currentTimeMillis()
					+ ">, elapsed = <" + elapsed + ">");

			/////////////////////////////////////////////////////

			startTime = System.currentTimeMillis();
			System.out
					.println("reading out citizen non-repudiation certificate");
			FileUtils.writeFile(prefix + "NonRepudiationCertificate.der", 			scd.getNonRepCertificateBytes());
			elapsed = System.currentTimeMillis() - startTime;

			System.out.println("time = <" + System.currentTimeMillis()
					+ ">, elapsed = <" + elapsed + ">");

			/////////////////////////////////////////////////////

			startTime = System.currentTimeMillis();
			System.out.println("reading citizen photo");
			FileUtils.writeFile(prefix + "Picture.jpg", 			scd.readCitizenPhotoBytes());
			elapsed = System.currentTimeMillis() - startTime;

			System.out.println("time = <" + System.currentTimeMillis()
					+ ">, elapsed = <" + elapsed + ">");

			/////////////////////////////////////////////////////

			startTime = System.currentTimeMillis();
			System.out.println("reading out citizen identity file signature");
			FileUtils.writeFile(prefix + "IdentityFileSignature.bin", 			scd.readIdentityFileSignatureBytes());
			elapsed = System.currentTimeMillis() - startTime;

			System.out.println("time = <" + System.currentTimeMillis()
					+ ">, elapsed = <" + elapsed + ">");

			/////////////////////////////////////////////////////

			startTime = System.currentTimeMillis();
			System.out.println("reading out citizen identity file");
			FileUtils.writeFile(prefix + "IdentityFile.bin", 			scd.readCitizenIdentityDataBytes());
			elapsed = System.currentTimeMillis() - startTime;

			System.out.println("time = <" + System.currentTimeMillis()
					+ ">, elapsed = <" + elapsed + ">");

			/////////////////////////////////////////////////////

			startTime = System.currentTimeMillis();
			System.out.println("reading out ca certificate");
			FileUtils.writeFile(prefix + "CaCertificate.der", 			scd.readCACertificateBytes());
			elapsed = System.currentTimeMillis() - startTime;

			System.out.println("time = <" + System.currentTimeMillis()
					+ ">, elapsed = <" + elapsed + ">");

			/////////////////////////////////////////////////////

			startTime = System.currentTimeMillis();
			System.out.println("reading out root ca certificate");
			FileUtils.writeFile(prefix + "RootCaCertificate.der", scd.readRootCACertificateBytes());
			elapsed = System.currentTimeMillis() - startTime;

			System.out.println("time = <" + System.currentTimeMillis()
					+ ">, elapsed = <" + elapsed + ">");

		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
}