package be.godot.sc.interfaces;

import be.godot.sc.exceptions.*;
import be.godot.sc.exceptions.SmartCardReaderException;
import be.godot.sc.exceptions.UnknownCardException;

import com.linuxnet.jpcsc.PCSCException;

public interface SmartCardInterface {
	public int type = 0;

	public byte[] getRandom(int length) throws PCSCException, Exception;

	public void verifyPin(String pinvalue) throws PCSCException,
			UnknownCardException, SmartCardReaderException, InvalidPinException;

	public void changePin(String currentPin, String newPin,
			String newPinConfirmation) throws PCSCException,
			UnknownCardException, SmartCardReaderException, InvalidPinException;

	public byte[] readBinaryFile(int fileSelectionCommand)
			throws UnknownCardException, SmartCardReaderException,
			InvalidResponse;

	public byte[] sendCommand(byte[] command) throws PCSCException;

	public void open() throws UnknownCardException, SmartCardReaderException;

	public String getSmartCardReaderName();

	public void close();

	public byte[] fetchATR();

}